from django.http import response
from API.views import jalan
from django.contrib.auth.models import User, Group
from django.shortcuts import render, redirect
# from django.views.generic import ListView, DetailView,  DeleteView, UpdateView, CreateView
from django.views import View, generic
from django.contrib.auth.decorators import login_required, user_passes_test
from django.utils.decorators import method_decorator
from django.db import connection as conn
# from edit import *

def get_per_user(req):
    us = req
    id = us.id
    print(id)
    with conn.cursor() as perm:
        perm.execute("""SELECT
                            json_build_object ( 'kab', gpk.kabupaten, 'pro', gpk.provinsi, 'id_apps', uaa.id_apps, 'apps', uaa.NAME )
                        FROM
                            user_apps_access uaa
                            JOIN geo_prov_kab gpk ON uaa.id_kab = gpk.id_kabupaten 
                        WHERE
                            uaa.id_user = %s"""% id)
        per = perm.fetchall()
    print(per)
    permm = per[0][0]
    
    return us, permm

def ui_params(id_app):
    with conn.cursor() as perm:
        perm.execute("""SELECT
                            json_build_object ( 'title', v1, 'logo', v2)
                        FROM
                            ui_params
                        WHERE
                            id_apps = %s"""% int(id_app))
        per = perm.fetchall()
        
    permm = per[0][0]
    return permm

# Create your views here.
class Dashboard(generic.TemplateView):
    template_name = "layout/layout.html"
    # @method_decorator(login_required(login_url='/login/'))
    
    
    def get(self, request):
        # if user.
        if request.user.is_authenticated:
            usern, perm = get_per_user(request.user)
            kab = perm['kab']
            # print(perm)
            ui_param = ui_params(perm['id_apps'])
            title = ui_param['title']
            logo = ui_param['logo']
            # print(ui_param)
            
            with conn.cursor() as batas:
                batas.execute("SELECT json_build_object('type', 'Feature', 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) from geo_prov_kab where kabupaten = '%s'"% kab)
                bts_res_ = batas.fetchall()
            
            bts_res = []
            for i in bts_res_:
                bts_res.append(i[0])
            
            with conn.cursor() as all_:
                all_.execute("SELECT * from global where kabupaten = '%s'"%  kab)
                all = all_.fetchall()
                
                if all == []:
                    all = [[]]
            
            with conn.cursor() as kel:
                kel.execute("""SELECT
                                json_build_object (
                                    'type',
                                    'Feature',
                                    'administrasi',
                                    ( kode_desa, desa, kecamatan, kab_kota, gdk.provinsi, jumlah_pen, jumlah_kk, luas_desa, 'NONE' ),
                                    'penduduk',
                                    (
                                        pria,
                                        wanita,
                                        belum_kawin,
                                        kawin,
                                        cerai_hidup,
                                        cerai_mati,
                                        wajib_ktp,
                                        islam,
                                        kristen,
                                        khatolik,
                                        hindu,
                                        budha,
                                        konghucu,
                                        kepercayaan_lain,
                                        u0,
                                        u5,
                                        u10,
                                        u15,
                                        u20,
                                        u25,
                                        u30,
                                        u35,
                                        u40,
                                        u45,
                                        u50,
                                        u55,
                                        u60,
                                        u65,
                                        u70,
                                        u75 
                                    ),
                                    'pekerjaan_pendidikan',
                                    (
                                        tidak_sekolah,
                                        belum_tamat,
                                        tamat_sd,
                                        sltp,
                                        slta,
                                        diploma_i,
                                        diploma_ii,
                                        diploma_iv,
                                        strata_ii,
                                        strata_iii,
                                        tidak_bekerja,
                                        aparatur_pemerintah,
                                        tenaga_pendidik,
                                        wiraswasta,
                                        pertanian,
                                        tenaga_kesehatan,
                                        pensiunan,
                                        pegawai,
                                        tentara,
                                        kepolisian,
                                        pedagang,
                                        petani,
                                        peternak,
                                        nelayan,
                                        karyawan,
                                        buruh,
                                        pembantu,
                                        tukang,
                                        pendeta,
                                        pastor,
                                        ustadz,
                                        dosen,
                                        guru,
                                        pilot,
                                        pengacara,
                                        notaris,
                                        arsitek,
                                        akuntan,
                                        konsultan,
                                        dokter,
                                        bidan,
                                        perawat,
                                        psikiater,
                                        sopir,
                                        lainnya 
                                    ),
                                    'poi',
                                    ( jml_puskesma, jml_sekolah, jml_sarib ),
                                    'geometry',
                                    ST_AsGeoJSON ( gdk.geom :: geometry ) :: json 
                                ) 
                            FROM
                                geo_data_kelurahan gdk
                                JOIN geo_prov_kab gpk ON st_intersects(gdk.geom, gpk.geom)
                            WHERE gpk.kabupaten = '%s'"""% kab)
                kel_res_ = kel.fetchall()
            
            with conn.cursor() as kec:
                kec.execute("""SELECT
                                    kecamatan,
                                    json_build_object (
                                        'type',
                                        'Feature',
                                        'administrasi',
                                        ( gdk.ID, gdk.kecamatan ),
                                        'geometry',
                                        ST_AsGeoJSON ( gdk.geom :: geometry ) :: json 
                                    ) 
                                FROM
                                    geo_data_kecamatan gdk
                                    JOIN geo_prov_kab gpk ON st_intersects ( gdk.geom, gpk.geom ) 
                                WHERE
                                    gpk.kabupaten = '%s'"""% kab)
                kec_res_ = kec.fetchall()
            
            kec_res = []
            for i in kec_res_:
                kec_res.append(i[1])
            
            kel_res = []
            for i in kel_res_:
                kel_res.append(i[0])
            
            with conn.cursor() as kantor_administrasi:
                kantor_administrasi.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.namobj,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_kantor_administrasi A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                kantor_administrasi_res = kantor_administrasi.fetchall()
                
            kantor_administrasi_result = []
            for i in kantor_administrasi_res:
                kantor_administrasi_result.append(i[0])
                
            with conn.cursor() as layanan_kesehatan:
                layanan_kesehatan.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.namobj,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_layanan_kesehatan A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                layanan_kesehatan_res = layanan_kesehatan.fetchall()
            
            layanan_kesehatan_result = []
            for i in layanan_kesehatan_res:
                layanan_kesehatan_result.append(i[0])
                
                
            with conn.cursor() as puskesmas:
                puskesmas.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_puskesmas A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                puskesmas_res = puskesmas.fetchall()
            
            puskesmas_result = []
            for i in puskesmas_res:
                puskesmas_result.append(i[0])
                
            with conn.cursor() as rumah_sakit:
                rumah_sakit.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_rumah_sakit A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                rumah_sakit_res = rumah_sakit.fetchall()
            
            rumah_sakit_result = []
            for i in rumah_sakit_res:
                rumah_sakit_result.append(i[0])
                
            with conn.cursor() as sarana_ibadah:
                sarana_ibadah.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_sarana_ibadah A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                sarana_ibadah_res = sarana_ibadah.fetchall()
            
            sarana_ibadah_result = []
            for i in sarana_ibadah_res:
                if i[0]["administrasi"]['f1'] == None:
                    i[0]["administrasi"]['f1'] = "None"
                sarana_ibadah_result.append(i[0])
                
            with conn.cursor() as sarana_pendidikan:
                sarana_pendidikan.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.namobj,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_sarana_pendidikan A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                sarana_pendidikan_res = sarana_pendidikan.fetchall()
            
            sarana_pendidikan_result = []
            for i in sarana_pendidikan_res:
                if i[0]["administrasi"]['f1'] == None:
                    i[0]["administrasi"]['f1'] = "None"
                sarana_pendidikan_result.append(i[0])
                
            with conn.cursor() as spbu:
                spbu.execute("""SELECT
                                    json_build_object (
                                        'type',
                                        'Feature',
                                        'administrasi',
                                        (
                                            A.namobj,
                                            A.remark,
                                            A.alamat,
                                            A.luas_bangunan,
                                            A.luas_tanah,
                                            A.satuan_luas_bangunan,
                                            A.satuan_luas_tanah,
                                            A.gambar,
                                            A.tinggi_bangunan,
                                            A.perangkat,
                                            A.tipe_gambar,
                                            b.kabupaten,
                                            c.kecamatan,
                                            d.desa,
                                            a.id
                                        ),
                                        'geometry',
                                        ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                    ) 
                                FROM
                                    geo_spbu A 
                                    JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                    JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                    join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                where b.kabupaten = '%s'"""% kab)
                spbu_res = spbu.fetchall()
            
            spbu_result = []
            for i in spbu_res:
                spbu_result.append(i[0])
                
            with conn.cursor() as stasiun:
                stasiun.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_stasiun A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                stasiun_res = stasiun.fetchall()
            
            stasiun_result = []
            for i in stasiun_res:
                stasiun_result.append(i[0])
                
            with conn.cursor() as terminal:
                terminal.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.luas,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_terminal_bus A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                terminal_res = terminal.fetchall()
            
            terminal_result = []
            for i in terminal_res:
                terminal_result.append(i[0])
                
            with conn.cursor() as cagar_budaya:
                cagar_budaya.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.gambar,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.luas,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_cagar_budaya A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                cagar_budaya_res = cagar_budaya.fetchall()
            
            cagar_budaya_result = []
            for i in cagar_budaya_res:
                cagar_budaya_result.append(i[0])
                
            with conn.cursor() as gardu_listrik:
                gardu_listrik.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_gardu_listrik A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                gardu_listrik_res = gardu_listrik.fetchall()
            
            gardu_listrik_result = []
            for i in gardu_listrik_res:
                gardu_listrik_result.append(i[0])
                
                
            parameter_ui = {'logo':logo, 'title':title}
            print(parameter_ui)
            context = {
            'parameter_ui':parameter_ui,
            'batas':bts_res,
            'title':title,
            'logo':logo,
            'kelurahan':kec_res,
            'kecamatan':kec_res,
            'kantor_administrasi':kantor_administrasi_result,
            'layanan_kesehatan':layanan_kesehatan_result,
            'puskesmas':puskesmas_result,
            'rumah_sakit':rumah_sakit_result,
            'sarana_ibadah':sarana_ibadah_result,
            'sarana_pendidikan':sarana_pendidikan_result,
            'spbu':spbu_result,
            'stasiun':stasiun_result,
            'terminal':terminal_result,
            'cagar_budaya':cagar_budaya_result,
            'gardu_listrik':gardu_listrik_result,
            'global':all[0]
            }
            return render (request, self.template_name, context)
        else:
            
            kab = 'KOTA CIMAHI'
            title = 'KAMI (Khansia Aset Manajemen and Inventory)'
            logo = 'khatulistiwalogotanpanama.png'
            
            with conn.cursor() as batas:
                batas.execute("SELECT json_build_object('type', 'Feature', 'geometry', ST_AsGeoJSON(geom :: geometry) :: json) from geo_prov_kab where kabupaten = '%s'"% kab)
                bts_res_ = batas.fetchall()
            
            bts_res = []
            for i in bts_res_:
                bts_res.append(i[0])
            
            with conn.cursor() as all_:
                all_.execute("SELECT * from global where kabupaten = '%s'"% kab)
                all = all_.fetchall()
                
                if all == []:
                    all = [[]]
            
            with conn.cursor() as kel:
                kel.execute("""SELECT
                                json_build_object (
                                    'type',
                                    'Feature',
                                    'administrasi',
                                    ( kode_desa, desa, kecamatan, kab_kota, provinsi, jumlah_pen, jumlah_kk, luas_desa, gambar ),
                                    'penduduk',
                                    (
                                        pria,
                                        wanita,
                                        belum_kawin,
                                        kawin,
                                        cerai_hidup,
                                        cerai_mati,
                                        wajib_ktp,
                                        islam,
                                        kristen,
                                        khatolik,
                                        hindu,
                                        budha,
                                        konghucu,
                                        kepercayaan_lain,
                                        u0,
                                        u5,
                                        u10,
                                        u15,
                                        u20,
                                        u25,
                                        u30,
                                        u35,
                                        u40,
                                        u45,
                                        u50,
                                        u55,
                                        u60,
                                        u65,
                                        u70,
                                        u75 
                                    ),
                                    'pekerjaan_pendidikan',
                                    (
                                        tidak_sekolah,
                                        belum_tamat,
                                        tamat_sd,
                                        sltp,
                                        slta,
                                        diploma_i,
                                        diploma_ii,
                                        diploma_iv,
                                        strata_ii,
                                        strata_iii,
                                        tidak_bekerja,
                                        aparatur_pemerintah,
                                        tenaga_pendidik,
                                        wiraswasta,
                                        pertanian,
                                        tenaga_kesehatan,
                                        pensiunan,
                                        pegawai,
                                        tentara,
                                        kepolisian,
                                        pedagang,
                                        petani,
                                        peternak,
                                        nelayan,
                                        karyawan,
                                        buruh,
                                        pembantu,
                                        tukang,
                                        pendeta,
                                        pastor,
                                        ustadz,
                                        dosen,
                                        guru,
                                        pilot,
                                        pengacara,
                                        notaris,
                                        arsitek,
                                        akuntan,
                                        konsultan,
                                        dokter,
                                        bidan,
                                        perawat,
                                        psikiater,
                                        sopir,
                                        lainnya 
                                    ),
                                    'poi',
                                    ( jml_puskesma, jml_sekolah, jml_sarib ),
                                    'geometry',
                                    ST_AsGeoJSON ( gdk.geom :: geometry ) :: json 
                                ) 
                            FROM
                                geo_data_kelurahan gdk
                            WHERE kab_kota = '%s'"""% kab)
                kel_res_ = kel.fetchall()
            
            with conn.cursor() as kec:
                kec.execute("""SELECT
                                    kecamatan,
                                    json_build_object (
                                        'type',
                                        'Feature',
                                        'administrasi',
                                        ( gdk.ID, gdk.kecamatan ),
                                        'geometry',
                                        ST_AsGeoJSON ( gdk.geom :: geometry ) :: json 
                                    ) 
                                FROM
                                    geo_data_kecamatan gdk
                                    JOIN geo_prov_kab gpk ON st_intersects ( gdk.geom, gpk.geom ) 
                                WHERE
                                    gpk.kabupaten = '%s'"""% kab)
                kec_res_ = kec.fetchall()
            
            kec_res = []
            for i in kec_res_:
                kec_res.append(i[1])
            
            kel_res = []
            for i in kel_res_:
                kel_res.append(i[0])
            
            with conn.cursor() as kantor_administrasi:
                kantor_administrasi.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.remark,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_kantor_administrasi A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                kantor_administrasi_res = kantor_administrasi.fetchall()
                
            kantor_administrasi_result = []
            for i in kantor_administrasi_res:
                kantor_administrasi_result.append(i[0])
                
            with conn.cursor() as layanan_kesehatan:
                layanan_kesehatan.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.namobj,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_layanan_kesehatan A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                layanan_kesehatan_res = layanan_kesehatan.fetchall()
            
            layanan_kesehatan_result = []
            for i in layanan_kesehatan_res:
                layanan_kesehatan_result.append(i[0])
                
                
            with conn.cursor() as puskesmas:
                puskesmas.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_puskesmas A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                puskesmas_res = puskesmas.fetchall()
            
            puskesmas_result = []
            for i in puskesmas_res:
                puskesmas_result.append(i[0])
                
            with conn.cursor() as rumah_sakit:
                rumah_sakit.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_rumah_sakit A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                rumah_sakit_res = rumah_sakit.fetchall()
            
            rumah_sakit_result = []
            for i in rumah_sakit_res:
                rumah_sakit_result.append(i[0])
                
            with conn.cursor() as sarana_ibadah:
                sarana_ibadah.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_sarana_ibadah A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                sarana_ibadah_res = sarana_ibadah.fetchall()
            
            sarana_ibadah_result = []
            for i in sarana_ibadah_res:
                if i[0]["administrasi"]['f1'] == None:
                    i[0]["administrasi"]['f1'] = "None"
                sarana_ibadah_result.append(i[0])
                
            with conn.cursor() as sarana_pendidikan:
                sarana_pendidikan.execute("""SELECT
                                                json_build_object (
                                                    'type',
                                                    'Feature',
                                                    'administrasi',
                                                    (
                                                        A.namobj,
                                                        A.remark,
                                                        A.alamat,
                                                        A.luas_bangunan,
                                                        A.luas_tanah,
                                                        A.satuan_luas_bangunan,
                                                        A.satuan_luas_tanah,
                                                        A.gambar,
                                                        A.tinggi_bangunan,
                                                        A.perangkat,
                                                        A.tipe_gambar,
                                                        b.kabupaten,
                                                        c.kecamatan,
                                                        d.desa,
                                                        a.id
                                                    ),
                                                    'geometry',
                                                    ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                                ) 
                                            FROM
                                                geo_sarana_pendidikan A 
                                                JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                                JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                                join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                            where b.kabupaten = '%s'"""% kab)
                sarana_pendidikan_res = sarana_pendidikan.fetchall()
            
            sarana_pendidikan_result = []
            for i in sarana_pendidikan_res:
                if i[0]["administrasi"]['f1'] == None:
                    i[0]["administrasi"]['f1'] = "None"
                sarana_pendidikan_result.append(i[0])
                
            with conn.cursor() as spbu:
                spbu.execute("""SELECT
                                    json_build_object (
                                        'type',
                                        'Feature',
                                        'administrasi',
                                        (
                                            A.namobj,
                                            A.remark,
                                            A.alamat,
                                            A.luas_bangunan,
                                            A.luas_tanah,
                                            A.satuan_luas_bangunan,
                                            A.satuan_luas_tanah,
                                            A.gambar,
                                            A.tinggi_bangunan,
                                            A.perangkat,
                                            A.tipe_gambar,
                                            b.kabupaten,
                                            c.kecamatan,
                                            d.desa,
                                            a.id
                                        ),
                                        'geometry',
                                        ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                    ) 
                                FROM
                                    geo_spbu A 
                                    JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                    JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                    join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                where b.kabupaten = '%s'"""% kab)
                spbu_res = spbu.fetchall()
            
            spbu_result = []
            for i in spbu_res:
                spbu_result.append(i[0])
                
            with conn.cursor() as stasiun:
                stasiun.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_stasiun A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                stasiun_res = stasiun.fetchall()
            
            stasiun_result = []
            for i in stasiun_res:
                stasiun_result.append(i[0])
                
            with conn.cursor() as terminal:
                terminal.execute("""SELECT
                                        json_build_object (
                                            'type',
                                            'Feature',
                                            'administrasi',
                                            (
                                                A.namobj,
                                                A.remark,
                                                A.alamat,
                                                A.luas_bangunan,
                                                A.luas_tanah,
                                                A.satuan_luas_bangunan,
                                                A.satuan_luas_tanah,
                                                A.gambar,
                                                A.tinggi_bangunan,
                                                A.perangkat,
                                                A.tipe_gambar,
                                                b.kabupaten,
                                                c.kecamatan,
                                                d.desa,
                                                a.luas,
                                                a.id
                                            ),
                                            'geometry',
                                            ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                        ) 
                                    FROM
                                        geo_terminal_bus A 
                                        JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                        JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                        join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                    where b.kabupaten = '%s'"""% kab)
                terminal_res = terminal.fetchall()
            
            terminal_result = []
            for i in terminal_res:
                terminal_result.append(i[0])
                
            with conn.cursor() as cagar_budaya:
                cagar_budaya.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.gambar,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.luas,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_cagar_budaya A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                cagar_budaya_res = cagar_budaya.fetchall()
            
            cagar_budaya_result = []
            for i in cagar_budaya_res:
                cagar_budaya_result.append(i[0])
                
            with conn.cursor() as gardu_listrik:
                gardu_listrik.execute("""SELECT
                                            json_build_object (
                                                'type',
                                                'Feature',
                                                'administrasi',
                                                (
                                                    A.namobj,
                                                    A.remark,
                                                    A.alamat,
                                                    A.luas_bangunan,
                                                    A.luas_tanah,
                                                    A.satuan_luas_bangunan,
                                                    A.satuan_luas_tanah,
                                                    A.gambar,
                                                    A.tinggi_bangunan,
                                                    A.perangkat,
                                                    A.tipe_gambar,
                                                    b.kabupaten,
                                                    c.kecamatan,
                                                    d.desa,
                                                    a.id
                                                ),
                                                'geometry',
                                                ST_AsGeoJSON ( A.geom :: geometry ) :: json 
                                            ) 
                                        FROM
                                            geo_gardu_listrik A 
                                            JOIN geo_prov_kab b ON st_intersects ( A.geom, b.geom )
                                            JOIN geo_data_kecamatan c ON st_intersects(A.geom, c.geom)
                                            join geo_data_kelurahan d on st_intersects(A.geom, d.geom)
                                        where b.kabupaten = '%s'"""% kab)
                gardu_listrik_res = gardu_listrik.fetchall()
            
            gardu_listrik_result = []
            for i in gardu_listrik_res:
                gardu_listrik_result.append(i[0])
        
        
        
            parameter_ui = {'logo':logo, 'title':title}
            print(parameter_ui)
            context = {
            'parameter_ui':parameter_ui,
            'batas':bts_res,
            'title':title,
            'logo':logo,
            'kelurahan':kel_res,
            'kecamatan':kec_res,
            'kantor_administrasi':kantor_administrasi_result,
            'layanan_kesehatan':layanan_kesehatan_result,
            'puskesmas':puskesmas_result,
            'rumah_sakit':rumah_sakit_result,
            'sarana_ibadah':sarana_ibadah_result,
            'sarana_pendidikan':sarana_pendidikan_result,
            'spbu':spbu_result,
            'stasiun':stasiun_result,
            'terminal':terminal_result,
            'cagar_budaya':cagar_budaya_result,
            'gardu_listrik':gardu_listrik_result,
            'global':all[0]
            }
            return render (request, self.template_name, context)
    

from django import template
from django.contrib.auth.models import Group
from rest_framework.decorators import api_view, renderer_classes
from rest_framework.response import Response


register = template.Library()

@register.filter(name='has_group')
def has_group(user, group_name):
    group = Group.objects.get(name=group_name)
    return True if group in user.groups.all() else False


def perbaikanrenovasi(request):
    with conn.cursor() as data_per:
        # data_per.execute("""
        #                  SELECT
        #                     gl.NAME,
        #                     tp.name,
        #                     tp.type,
        #                     st_length ( gj.geom :: geography ),
        #                     tp.tgl_pembuatan,
        #                     tp.tgl_perbaikan,
        #                     tp.anggaran,
        #                     tp.proposal,
        #                     tp.pj,
        #                     tp.pj_lapangan,
        #                     tp.kontraktor,
        #                     ST_AsGeoJSON ( tp.geom :: geometry ) :: json,
        #                     tp.pjg_perbaikan,
        #                     tp.lbr_perbaikan,
        #                     tp.id_object
        #                 FROM
        #                     tbl_perbaikan tp
        #                     JOIN geo_label gl ON gl.ID = tp.type_id
        #                     JOIN geo_jalan gj ON gj.ID = tp.id_object
        #                  """)
        data_per.execute("""
                         SELECT
                            gl.NAME,
                            tp.id_object,
                            tp.NAME,
                            tp.TYPE,
                            tp.tgl_perbaikan,
                            tp.anggaran,
                            tp.tgl_selesai
                        FROM
                            ( SELECT tbl_perbaikan.*, ROW_NUMBER ( ) OVER ( PARTITION BY id_object ORDER BY tgl_selesai DESC ) AS rn FROM tbl_perbaikan ) tp
                            JOIN geo_label gl ON gl.ID = tp.type_id 
                        WHERE
                            rn = 1
                         """)
        res_perbaikan = data_per.fetchall()
    
    res_all = []
    for j in res_perbaikan:
        print(j[0])
        # if j[0] == 'jalan':
        data_all = {
            'name_perbaikan':j[0],
            'id_object':j[1],
            'name':j[2],
            'type':j[3],
            'tgl_perbaikan':j[4],
            'anggaran':j[5],
            'tgl_selesai':j[6],
        }
        res_all.append(data_all)
            
    context = {'res_all':res_all}
    return render(request, 'maps/perbaikan.html', context)

@api_view(('POST',))
def loadDetail(request):
    id_object = request.POST.get('id')
    with conn.cursor() as data_per:
        data_per.execute("""
                         SELECT
                            gl.NAME,
                            tp.name,
                            gj.remark,
                            st_length ( gj.geom :: geography ),
                            tp.tgl_pembuatan,
                            tp.tgl_perbaikan,
                            tp.tgl_selesai,
                            tp.anggaran,
                            tp.pj,
                            tp.pj_lapangan,
                            tp.kontraktor,
                            ST_AsGeoJSON ( tp.geom :: geometry ) :: json,
                            tp.pjg_perbaikan,
                            tp.lbr_perbaikan,
                            tp.id_object,
                            tp.id,
                            tp.proposal,
                            tp.bukti_selesai
                        FROM
                            tbl_perbaikan tp
                            JOIN geo_label gl ON gl.ID = tp.type_id
                            JOIN geo_jalan gj ON gj.ID = tp.id_object
                        where tp.id_object = %s"""% id_object)
        res_perbaikan = data_per.fetchall()
        
    res_all = []
    for j in res_perbaikan:
        data_all = {
                'name':j[1],
                'type':j[2],
                'panjang':j[3],
                'tgl_pembuatan':j[4],
                'tgl_perbaikan':j[5],
                'tgl_selesai':j[6],
                'anggaran':j[7],
                'pj':j[8],
                'pj_lapangan':j[9],
                'kontraktor':j[10],
                'geometry':j[11],
                'pjg_jln_reno':j[12],
                'lbr_jln_reno':j[13],
                'id_object':j[14],
                'id':j[15],
                'proposal':j[16],
                'bukti_selesai':j[17]
            }
        res_all.append(data_all)

    respon =res_all
    return Response(respon)

@api_view(('GET',))
def inpuperbaikan(request):
    id = request.GET.get('id_jalan')
    with conn.cursor() as data_per:
        data_per.execute("""
                         SELECT
                            namrjl,
                            remark,
                            st_length ( geom :: geography ),
                            json_build_object (
                                        'type', 'Feature',
                                        'geometry', ST_AsGeoJSON ( geom :: geometry ) :: json ) ,
                            id,
                            type_id
                        FROM
                            geo_jalan
                        where id = %s
                         """% id)
        res_data = data_per.fetchall()
    
    respon = res_data[0]
    return Response(respon)

@api_view(('GET',))
def inputperbaikanbangunan(request):
    id = request.GET.get('id_bangunan')
    with conn.cursor() as data_per:
        data_per.execute("""
                         SELECT
                            name,
                            type_id,
                            json_build_object ( 'type', 'Feature', 'geometry', ST_AsGeoJSON ( geom :: geometry ) :: json ),
                            ID,
                            remark,
                            address_1,
                            address_2
                        FROM
                            geo_bangunan 
                        WHERE
                            ID = %s
                         """% id)
        res_data = data_per.fetchall()
    
    respon = res_data[0]
    return Response(respon)

from django.core.files.storage import FileSystemStorage
import random
import re
import json
@api_view(('POST',))
def saveperbaikan(request):
    type_id         = request.POST.get("type_id")
    id_object       = request.POST.get("object_id")
    name            = request.POST.get("name")
    type            = request.POST.get("type")
    tgl_pembuatan   = request.POST.get("tgl_pembuatan")
    tgl_perbaikan   = request.POST.get("tgl_perbaikan")
    tgl_disetujui   = request.POST.get("tgl_disetujui")
    anggaran        = request.POST.get("anggaran")
    
    
    pj              = request.POST.get("pj")
    pj_lapangan     = request.POST.get("pj_lapangan")
    kontraktor      = request.POST.get("kontraktor")
    pjg_perbaikan   = request.POST.get("pjg_perbaikan")
    lbr_perbaikan   = request.POST.get("lbr_perbaikan")
    jenis_perbaikan = request.POST.get("jenis_perbaikan")
    luas            = request.POST.get("luas")
    coor            = request.POST.get("coord")
    tgl_selesai     = request.POST.get("tgl_selesai")
    
    proposal        = request.FILES.get("proposal")
    bukti_selesai   = request.FILES.get("bukti_selesai")
    print(coor, proposal)
    
    
    
    fss_p = FileSystemStorage(location='/var/www/django/oku.khansia.co.id/media/proposal/')
    fss_b = FileSystemStorage(location='/var/www/django/oku.khansia.co.id/media/bukti_penyelesaian/')
    
    coord = json.loads(str(coor))
    
    pjg_perbaikan = re.sub('[^0-9.]+', '', str(pjg_perbaikan))
    lbr_perbaikan = re.sub('[^0-9.]+', '', str(lbr_perbaikan))
    luas = re.sub('[^0-9.]+', '', str(luas))
    
    if coord['features'][0]['geometry']['type'] == 'LineString':
        print("oke")
        for co in coord['features']:
            ll = str(co["geometry"]['coordinates'])
            ll += ll
        ll = ll.replace(", "," ")
        ll = ll.replace("]][[","),(")
        ll = ll.replace("] [",", ")
        ll = ll.replace("]]",")")
        ll = ll.replace("[[","(")

        coordinat = f'MULTILINESTRING({ll})'
        print(ll)
    if coord['features'][0]['geometry']['type'] == 'Polygon':
        print('tidakoke')
        
    try:
        format = (proposal.name).split(".")
        num = random.randrange(1, 10000000000000)
        nproposal = f"{name}_{num}.{format[-1:][0]}"
        nproposal = nproposal.replace(" ","-")
        filename_p = fss_p.save(nproposal, proposal)
        url_p = fss_p.url(filename_p)

        format_ = (bukti_selesai.name).split(".")
        nbukti = f"{name}_{num}.{format_[-1:][0]}"
        nbukti = nbukti.replace(" ","-")
        filename_b = fss_b.save(nbukti, bukti_selesai)
        url_b = fss_b.url(filename_b)
        
        with conn.cursor() as data_per:
            data_per.execute("""
                        INSERT INTO tbl_perbaikan (
                            type_id,
                            id_object,
                            name,
                            type,
                            tgl_selesai,
                            tgl_perbaikan,
                            tgl_disetujui,
                            anggaran,
                            proposal,
                            bukti_selesai,
                            pj,
                            pj_lapangan,
                            kontraktor,
                            pjg_perbaikan,
                            lbr_perbaikan,
                            jenis_perbaikan,
                            geom
                        )
                        VALUES
                            (
                                %s,
                                %s,
                                '%s',
                                '%s',
                                '%s',
                                '%s',
                                '%s',
                                %s,
                                '%s',
                                '%s',
                                '%s',
                                '%s',
                                '%s',
                                %s,
                                %s,
                                '%s',
                                ST_GeomFromText('%s')
                            )
                            """% (
                                int(type_id),
                                int(id_object),
                                name,
                                type,
                                tgl_selesai,
                                tgl_perbaikan,
                                tgl_disetujui,
                                int(anggaran),
                                nproposal,
                                nbukti,
                                pj,
                                pj_lapangan,
                                kontraktor,
                                float(pjg_perbaikan),
                                float(lbr_perbaikan),
                                jenis_perbaikan,
                                coordinat))
        conn.commit()
        data = "Sukses"
        info = "Data Telah Berhasil di Perbaharui"
        code = 0

    except:
        data = "Pastikan Semua Data Terisi Termasuk Proposal dan Bukti Selesai"
        info = "Oops"
        code = 1
    respon = {"data":data,"info":info,"code":code}
    return Response(respon)

# from django.core.files.storage import FileSystemStorage
# import random
# import re
# import json
@api_view(('POST',))
def saveperbaikanbangunan(request):
    type_id         = '1'
    id_object       = request.POST.get("object_idbang")
    name            = request.POST.get("namebang")
    type            = request.POST.get("typebang")
    # tgl_pembuatan   = request.POST.get("tgl_pembuatanbang")
    tgl_perbaikan   = request.POST.get("tgl_perbaikanbang")
    tgl_disetujui   = request.POST.get("tgl_disetujuibang")
    anggaran        = request.POST.get("anggaranbang")
    
    
    pj              = request.POST.get("pjbang")
    pj_lapangan     = request.POST.get("pj_lapanganbang")
    kontraktor      = request.POST.get("kontraktorbang")
    jenis_perbaikan = request.POST.get("jenis_perbaikanbang")
    coor            = request.POST.get("coordbang")
    
    # for co in coor['features']:
    # ll = coor['geometry']['coordinates']
    # ll += ll
    # ll = ll.replace(", "," ")
    # ll = ll.replace("]][[","),(")
    # ll = ll.replace("] [",", ")
    # ll = ll.replace("]]",")")
    # ll = ll.replace("[[","(")
    # corcoran = ll
    # p_create = coor.replace('"','')
    # po_create = p_create.replace(', ','],[')
    # cood_edit = json.loads(coor)
    # co_edit = cood_edit['geometry']['coordinates']
    
    yak = str(coor)
    suk = yak.replace("""{"type":"Feature","properties":{},"geometry":{"type":"Polygon","coordinates":""","")
    sik = suk.replace("""}}""","")
    cor = sik.replace("""[[[""","((")
    coran = cor.replace("""]]]""","))")
    ll = coran.replace(","," ")
    ii = ll.replace("] [",",")
    
    corcoran = f'MULTIPOLYGON({ii})'
    print("-------------------")
    print(str(corcoran))
    print("-------------------")
    # print(yak)
    tgl_selesai     = request.POST.get("tgl_selesaibang")
    
    proposal        = request.FILES.get("proposal_bang")
    bukti_selesai   = request.FILES.get("bukti_selesai_bang")
    print((proposal.name).split("."))
    print((bukti_selesai.name).split("."))
    
    fss_p = FileSystemStorage(location='/var/www/django/oku.khansia.co.id/media/proposal/')
    fss_b = FileSystemStorage(location='/var/www/django/oku.khansia.co.id/media/bukti_penyelesaian/')

    try:
        format1 = (proposal.name).split(".")
        num = random.randrange(1, 10000000000000)
        nproposal = f"{name}_{num}.{format1[-1:][0]}"
        nproposal = nproposal.replace(" ","-")
        filename_p = fss_p.save(nproposal, proposal)
        url_p = fss_p.url(filename_p)

        format2 = (bukti_selesai.name).split(".")
        nbukti = f"{name}_{num}.{format2[-1:][0]}"
        nbukti = nbukti.replace(" ","-")
        filename_b = fss_b.save(nbukti, bukti_selesai)
        url_b = fss_b.url(filename_b)
        
        with conn.cursor() as data_per:
            data_per.execute("""
                            INSERT INTO tbl_perbaikan (
                                type_id,
                                id_object,
                                name,
                                type,
                                tgl_selesai,
                                tgl_perbaikan,
                                tgl_disetujui,
                                anggaran,
                                proposal,
                                bukti_selesai,
                                pj,
                                pj_lapangan,
                                kontraktor,
                                jenis_perbaikan,
                                geom
                            )
                            VALUES
                                (
                                    %s,
                                    %s,
                                    '%s',
                                    '%s',
                                    '%s',
                                    '%s',
                                    '%s',
                                    %s,
                                    '%s',
                                    '%s',
                                    '%s',
                                    '%s',
                                    '%s',
                                    '%s',
                                    ST_GeomFromText('%s')
                                )
                                """% (
                                    int(type_id),
                                    int(id_object),
                                    name,
                                    type,
                                    tgl_selesai,
                                    tgl_perbaikan,
                                    tgl_disetujui,
                                    int(anggaran),
                                    nproposal,
                                    nbukti,
                                    pj,
                                    pj_lapangan,
                                    kontraktor,
                                    jenis_perbaikan,
                                    corcoran))
        conn.commit()
        data = "Sukses"
        info = "Data Telah Berhasil di Perbaharui"
        code = 0

    except:
        data = "Pastikan Semua Data Terisi Termasuk Proposal dan Bukti Selesai"
        info = "Oops"
        code = 1
    respon = {"data":data,"info":info,"code":code}
    return Response(respon)

@api_view(('GET',))
def loadbyiddetail(request):
    id = request.GET.get('id')
    id_jl = request.GET.get('id_jl')
    with conn.cursor() as detail_maps:
        detail_maps.execute("""
                            SELECT
                                json_build_object (
                                        'type', 'Feature',
                                        'geometry', ST_AsGeoJSON ( a.geom :: geometry ) :: json ),
                                json_build_object (
                                        'type', 'Feature',
                                        'geometry', ST_AsGeoJSON ( b.geom :: geometry ) :: json )
                            from 
                                tbl_perbaikan a, geo_jalan b
                            where
                                a.id = %s and b.id = %s
                            """% (id, id_jl))
        detail_ = detail_maps.fetchone()
    print(detail_)
    respon=detail_
    return Response(respon)

@api_view(('GET',))
def getjalanperbaikan(request):
    id = request.GET.get('id')

    with conn.cursor() as detail_maps:
        detail_maps.execute("""
                            SELECT
                                json_build_object (
                                        'type', 'Feature',
                                        'geometry', ST_AsGeoJSON ( a.geom :: geometry ) :: json )
                            from 
                                tbl_perbaikan a
                            where
                                a.id = %s
                            """% id)
        detail_ = detail_maps.fetchone()
    print(detail_)
    respon=detail_
    return Response(respon)

@api_view(('GET',))
def getdetailperbaikan(request):
    id_object = request.GET.get('id')
    with conn.cursor() as data_per:
        data_per.execute("""
                         SELECT
                            gl.NAME,
                            tp.name,
                            gj.remark,
                            st_length ( gj.geom :: geography ),
                            tp.tgl_pembuatan,
                            tp.tgl_perbaikan,
                            tp.tgl_selesai,
                            tp.anggaran,
                            tp.pj,
                            tp.pj_lapangan,
                            tp.kontraktor,
                            ST_AsGeoJSON ( tp.geom :: geometry ) :: json,
                            tp.pjg_perbaikan,
                            tp.lbr_perbaikan,
                            tp.id_object,
                            tp.id,
                            tp.proposal,
                            tp.bukti_selesai
                        FROM
                            tbl_perbaikan tp
                            JOIN geo_label gl ON gl.ID = tp.type_id
                            JOIN geo_jalan gj ON gj.ID = tp.id_object
                        where tp.id = %s"""% id_object)
        res_perbaikan = data_per.fetchall()
                
    res_all = []
    for j in res_perbaikan:
        data_all = {
                'name':j[1],
                'type':j[2],
                'panjang':j[3],
                'tgl_pembuatan':j[4],
                'tgl_perbaikan':j[5],
                'tgl_selesai':j[6],
                'anggaran':j[7],
                'pj':j[8],
                'pj_lapangan':j[9],
                'kontraktor':j[10],
                'geometry':j[11],
                'pjg_jln_reno':j[12],
                'lbr_jln_reno':j[13],
                'id_object':j[14],
                'id':j[15],
                'proposal':j[16],
                'bukti_selesai':j[17]
            }
        res_all.append(data_all)

    respon =res_all
    return Response(respon)

@api_view(('GET',))
def getdetailperbaikanbangunan(request):
    id_object = request.GET.get('id')
    with conn.cursor() as data_per:
        data_per.execute("""
                         SELECT
                            gl.NAME,
                            tp.name,
                            gj.remark,
                            tp.tgl_pembuatan,
                            tp.tgl_perbaikan,
                            tp.tgl_selesai,
                            tp.anggaran,
                            tp.pj,
                            tp.pj_lapangan,
                            tp.kontraktor,
                            ST_AsGeoJSON ( tp.geom :: geometry ) :: json,
                            tp.id_object,
                            tp.id,
                            tp.proposal,
                            tp.bukti_selesai,
                            tp.jenis_perbaikan
                        FROM
                            tbl_perbaikan tp
                            JOIN geo_label gl ON gl.ID = tp.type_id
                            JOIN geo_bangunan gj ON gj.ID = tp.id_object
                        where tp.id_object = %s
                        order by tp.tgl_perbaikan desc"""% id_object)
        res_perbaikan = data_per.fetchall()
                
    res_all = []
    for j in res_perbaikan:
        data_all = {
                'name':j[1],
                'type':j[2],
                'tgl_pembuatan':j[3],
                'tgl_perbaikan':j[4],
                'tgl_selesai':j[5],
                'anggaran':j[6],
                'pj':j[7],
                'pj_lapangan':j[8],
                'kontraktor':j[9],
                'geometry':j[10],
                'id_object':j[11],
                'id':j[12],
                'proposal':j[13],
                'bukti_selesai':j[14],
                'jenis_perbaikan':j[15]
            }
        res_all.append(data_all)

    respon = res_all
    return Response(respon)

@api_view(('GET',))
def editkelurahan(request):
    kode_dagri = request.GET.get('kode_dagri')
    
    with conn.cursor() as edit_poly:
        edit_poly.execute("SELECT json_build_object('type', 'Feature', 'administrasi', json_build_array(kode_desa, desa, kecamatan, kab_kota, provinsi, jumlah_pen, jumlah_kk, luas_desa),'penduduk', json_build_array(pria, wanita, belum_kawin, kawin, cerai_hidup, cerai_mati, wajib_ktp, islam, kristen, khatolik, hindu, budha, konghucu, kepercayaan_lain, u0, u5, u10, u15, u20, u25, u30, u35, u40, u45, u50, u55, u60, u65, u70, u75),'pekerjaan_pendidikan', json_build_array(tidak_sekolah, belum_tamat, tamat_sd, sltp, slta, diploma_i, diploma_ii, diploma_iv, strata_ii, strata_iii, tidak_bekerja, aparatur_pemerintah, tenaga_pendidik, wiraswasta, pertanian, tenaga_kesehatan, pensiunan, pegawai, tentara, kepolisian, pedagang, petani, peternak, nelayan, karyawan, buruh, pembantu, tukang, pendeta, pastor, ustadz, dosen, guru, pilot, pengacara, notaris, arsitek, akuntan, konsultan, dokter, bidan, perawat, psikiater, sopir, lainnya), 'poi',json_build_array(jml_puskesma, jml_sekolah, jml_sarib),'geometry', ST_AsGeoJSON(geom :: geometry) :: json) from geo_data_kelurahan where kode_desa = '%s'"% kode_dagri)
        res_edit_poly = edit_poly.fetchall()
        
    print(res_edit_poly)
    
    la = []
    lo = []
    for i in res_edit_poly[0][0]['geometry']['coordinates'][0][0]:
        la.append(i[0])
        lo.append(i[1])
        
    avg_la = sum(la)/len(la)
    avg_lo = sum(lo)/len(lo)
    
    desa = res_edit_poly[0][0]['administrasi'][1]
    kec = res_edit_poly[0][0]['administrasi'][2]
    kab = res_edit_poly[0][0]['administrasi'][3]
    prov = res_edit_poly[0][0]['administrasi'][4]
    context = {'desa':desa, 'kec':kec, 'kab':kab, 'prov':prov,'result_poly': res_edit_poly[0][0], 'avg_la':avg_la, 'avg_lo':avg_lo}
    return Response(context)

from .forms import NewUserForm
from django.contrib import messages
from django.contrib.auth import login
from django.contrib.auth.models import User
from django.contrib.auth.hashers import make_password

def registrasi_new_app(request):
    if request.method == 'POST':
        form = NewUserForm(request.POST)
        username = request.POST.get('username')
        password = request.POST.get('password2')
        name_app = request.POST.get('app_name')
        teritory_name = request.POST.get('teritory_name')
        user = User()
        
        user.username    = username
        user.password    = make_password(password)
        user.save()
        try:
            with conn.cursor() as insert_app_name:
                insert_app_name.execute("""INSERT INTO ui_params (v1) VALUES ('%s')"""% name_app)
            conn.commit()    
            
            with conn.cursor() as select_id_app_name:
                select_id_app_name.execute("""SELECT id_apps FROM ui_params WHERE v1 = '%s' limit 1"""% name_app)
                id_app = select_id_app_name.fetchall()
                
            with conn.cursor() as insert_id_app_name:
                insert_id_app_name.execute("""INSERT INTO user_apps_access (id_apps, name, id_user, id_kab, id_pro) (SELECT %s, '%s', %s, id_kabupaten, id_provinsi FROM geo_prov_kab WHERE kabupaten = '%s')"""% (id_app[0][0], name_app, user.id, teritory_name))
                
            conn.commit()

        except:
            print('eror')
        
        

        messages.success(request, "Registration successful." )
        return redirect("/")
        # return render(request, "reg_new_app.html")
        # messages.error(request, "Unsuccessful registration. Invalid information.")
    
    with conn.cursor() as ter:
        ter.execute("""select kabupaten from geo_prov_kab order by provinsi asc""")
        
        teri = ter.fetchall()
    teritor = []
    for i in teri:
        teritor.append(i[0])
    
    return render (request, "reg_new_app.html", context={'teritor':teritor})